	using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Samples.Singleton.WinForm
{
	/// <summary>
	/// Summary description for MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.StatusBar _statusBar;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button _secondFormButton;

		private static MainForm _instance = new MainForm();
		private MainForm()
		{
			InitializeComponent();
		}

		public static MainForm Instance 
		{
			get 
			{
				return _instance;
			}
		}

		public void ShowStatusText(string text) 
		{
			_statusBar.Text = text;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this._statusBar = new System.Windows.Forms.StatusBar();
			this._secondFormButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// _statusBar
			// 
			this._statusBar.Location = new System.Drawing.Point(0, 248);
			this._statusBar.Name = "_statusBar";
			this._statusBar.Size = new System.Drawing.Size(560, 22);
			this._statusBar.TabIndex = 0;
			// 
			// _secondFormButton
			// 
			this._secondFormButton.Location = new System.Drawing.Point(240, 104);
			this._secondFormButton.Name = "_secondFormButton";
			this._secondFormButton.Size = new System.Drawing.Size(80, 23);
			this._secondFormButton.TabIndex = 1;
			this._secondFormButton.Text = "Second form";
			this._secondFormButton.Click += new System.EventHandler(this._secondFormButton_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(560, 270);
			this.Controls.Add(this._secondFormButton);
			this.Controls.Add(this._statusBar);
			this.Name = "MainForm";
			this.Text = "MainForm";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			// Application.Run(new MainForm());
			Application.Run(MainForm.Instance);
		}

		private void _secondFormButton_Click(object sender, System.EventArgs e)
		{
			SecondForm second = new SecondForm();
			second.ShowDialog(this);
		}
	}
}
